package frc.robot.constants;

import com.revrobotics.spark.ClosedLoopSlot;
import com.revrobotics.spark.config.SparkMaxConfig;
import com.revrobotics.spark.config.MAXMotionConfig.MAXMotionPositionMode;

public class ClosedLoopTestConstants {
    public static final double kPositionConversionFactor = 360.0/25.0;
    public static final double kVelocityConversionFactor = kPositionConversionFactor / 60.0;

    public static final double kVeloP = 0.001;
    public static final double kVeloI = 0;
    public static final double kVeloD = 0;
    public static final double kVeloF = 0;

    public static final double kPosP = 0.001;
    public static final double kPosI = 0;
    public static final double kPosD = 0;

    public static final double kAllowedClosedLoopError = 4;
    public static final double kMaxAcceleration = 180;
    public static final double kMaxVelocity = 360;

    public static final SparkMaxConfig motorConfig = new SparkMaxConfig();

    static {
        motorConfig.encoder
            .positionConversionFactor(kPositionConversionFactor)
            .velocityConversionFactor(kVelocityConversionFactor);
        motorConfig.closedLoop
            .pidf(
                kVeloP, 
                kVeloI, 
                kVeloD, 
                kVeloF, 
                ClosedLoopSlot.kSlot0
            ).pid(
                kPosP, 
                kPosI, 
                kPosD,
                ClosedLoopSlot.kSlot1
            );
        motorConfig.closedLoop.maxMotion
            .allowedClosedLoopError(kAllowedClosedLoopError)
            .maxAcceleration(kMaxAcceleration)
            .maxVelocity(kMaxVelocity).positionMode(MAXMotionPositionMode.kMAXMotionTrapezoidal);
    }
}
